<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑处方明细表' : '添加处方明细表'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="关联处方" name="prescriptionId">
        <a-input
          allow-clear
          placeholder="请输入关联处方"
          v-model:value="form.prescriptionId"
        />
      </a-form-item>
      <a-form-item label="订单编号" name="prescriptionNo">
        <a-input
          allow-clear
          placeholder="请输入订单编号"
          v-model:value="form.prescriptionNo"
        />
      </a-form-item>
      <a-form-item label="关联药品" name="medicineId">
        <a-input
          allow-clear
          placeholder="请输入关联药品"
          v-model:value="form.medicineId"
        />
      </a-form-item>
      <a-form-item label="剂量（如“10g”）" name="dosage">
        <a-input
          allow-clear
          placeholder="请输入剂量（如“10g”）"
          v-model:value="form.dosage"
        />
      </a-form-item>
      <a-form-item label="用法频率（如“每日三次”）" name="usageFrequency">
        <a-input
          allow-clear
          placeholder="请输入用法频率（如“每日三次”）"
          v-model:value="form.usageFrequency"
        />
      </a-form-item>
      <a-form-item label="服用天数" name="days">
        <a-input
          allow-clear
          placeholder="请输入服用天数"
          v-model:value="form.days"
        />
      </a-form-item>
      <a-form-item label="购买数量" name="amount">
        <a-input
          allow-clear
          placeholder="请输入购买数量"
          v-model:value="form.amount"
        />
      </a-form-item>
      <a-form-item label="单价" name="unitPrice">
        <a-input
          allow-clear
          placeholder="请输入单价"
          v-model:value="form.unitPrice"
        />
      </a-form-item>
      <a-form-item label="数量" name="quantity">
        <a-input
          allow-clear
          placeholder="请输入数量"
          v-model:value="form.quantity"
        />
      </a-form-item>
      <a-form-item label="排序号" name="sortNumber">
        <a-input-number
          :min="0"
          :max="9999"
          class="ele-fluid"
          placeholder="请输入排序号"
          v-model:value="form.sortNumber"
        />
      </a-form-item>
      <a-form-item label="备注" name="comments">
        <a-textarea
          :rows="4"
          :maxlength="200"
          placeholder="请输入描述"
          v-model:value="form.comments"
        />
      </a-form-item>
      <a-form-item label="用户id" name="userId">
        <a-input
          allow-clear
          placeholder="请输入用户id"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="更新时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入更新时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject } from 'ele-admin-pro';
  import {
    addClinicPrescriptionItem,
    updateClinicPrescriptionItem
  } from '@/api/clinic/clinicPrescriptionItem';
  import { ClinicPrescriptionItem } from '@/api/clinic/clinicPrescriptionItem/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ClinicPrescriptionItem | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ClinicPrescriptionItem>({
    id: undefined,
    prescriptionId: undefined,
    prescriptionNo: undefined,
    medicineId: undefined,
    dosage: undefined,
    usageFrequency: undefined,
    days: undefined,
    amount: undefined,
    unitPrice: undefined,
    quantity: undefined,
    userId: undefined,
    tenantId: undefined,
    updateTime: undefined,
    createTime: undefined,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    clinicPrescriptionItemName: [
      {
        required: true,
        type: 'string',
        message: '请填写处方明细表名称',
        trigger: 'blur'
      }
    ]
  });

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value
          ? updateClinicPrescriptionItem
          : addClinicPrescriptionItem;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
